///////////////////////////////////////////////////////////////////////////////////
// A4 main wdl
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "models";	// Path to model subdirectory - if any
path "sounds";	// Path to sound subdirectory - if any
path "bmaps";		// Path to graphics subdirectory - if any
Path "C:\\PROGRAMME\\GSTUDIO\\template";	// Path to WDL templates subdirectory
path "level2";
path "level3";

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions
include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;		// must be inserted before doors and weapons
include <particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
include <actors.wdl>;   // remove when you need no actors
include <weapons.wdl>;  // remove when you need no weapons
include <war.wdl>;      // remove when you need no fighting
//include <venture.wdl>;	// include when doing an adventure

////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 6;	 // screen size 640x480
var video_depth = 16; // 16 bit colour D3D mode
/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap splashmap = <splash.pcx>; // the default A4 logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh, d3d;	// d3d can be omitted for saving video memory
}

/////////////////////////////////////////////////////////////////
// The main() function is started at game start
STRING mission_str = "Finden Sie das Bayernmaster-Wappen!";
string levelchange_str = "Einen moment bitte! Level wird geladen!";
function main()
{
// center the splash screen for non-640x480 resolutions
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
// display the splash screen
	splashscreen.visible = on;
// wait 2 frames until it is rendered and flipped to the foreground
	wait(16);

// now load the level
	load_level(<test2.WMB>);
// wait at least one frame until the level is loaded
// wait the rest of the required second, then switch the splashscreen off.
	waitt(8);
  	splashscreen.visible = off;

// load some global variables, like sound volume
	load_status();

//	client_move();	// for a possible multiplayer game
// call further functions here...
msg.string = mission_str;
show_message();
show_panels();
}

/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"A4 Engine";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(240,240,240);
	FRAME			FTYP1,0,0,480,320;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/

/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;


action my_hero {
MY._WALKFRAMES = 1;
MY._ENTFORCE = 0.75;
MY._PENDOLINO = -0.1;
MY._MOVEMODE = _MODE_WALKING;
MY.__JUMP = ON;
MY.__STRAFE = ON;
MY.__BOB = ON;
MY.NARROW = ON;
MY.FAT = OFF;
player_move();
player_fight();
drop_shadow();
}


action my_enemy {
MY._WALKFRAMES = 1;
MY._RUNFRAMES = 4.050;
MY._ATTACKFRAMES = 6;
MY._DIEFRAMES = 1;
MY._ENTFORCE = 2;
MY._FIREMODE = DAMAGE_SHOOT+FIRE_PARTICLE+HIT_FLASH+0.15;
MY._HITMODE = HIT_EXPLO;
MY._WALKSOUND = _SOUND_ROBOT;
actor_fight();
if (MY.FLAG4 == ON) { patrol_path(); };
drop_shadow();
}


action my_enemybvb {
MY._WALKFRAMES = 1;
MY._RUNFRAMES = 4.050;
MY._ATTACKFRAMES = 3;
MY._DIEFRAMES = 1;
MY._ENTFORCE = 3;
MY._FIREMODE = DAMAGE_EXPLODE+FIRE_BALL+HIT_EXPLO+BULLET_SMOKETRAIL+HIT_FLASH+0.15;
MY._HITMODE = HIT_EXPLO;
MY._WALKSOUND = _SOUND_ROBOT;
actor_fight();
if (MY.FLAG4 == ON) { patrol_path(); };
drop_shadow();
}


action Load_level2 
{
MY.ENABLE_IMPACT = ON; //Levelwechsel durch dagegen laufen
SET MY.EVENT,level_level2; 
}
Action level_level2 {
MY = NULL;
LOAD_LEVEL "level2.wmb";
wait(1);
weapon_restore();
}

action Load_level3 {
MY.ENABLE_IMPACT = ON; //Levelwechsel durch dagegen laufen
SET MY.EVENT,level_level3; 
}
Action level_level3 {
MY = NULL;
LOAD_LEVEL "level3.wmb";

}


function weapon_restore()
{
if (weapon_1 !=0) {CREATE(<shotgun.mdl>,NULLVECTOR, sparkgun); }
if (weapon_2 !=0) {CREATE(<waffe2.mdl>,NULLVECTOR, flashgun); }

gun_select();
}